<Query Kind="Program">
  <Namespace>System.Threading.Tasks</Namespace>
</Query>

void Main()
{
	var itemList =
		from num in Enumerable.Range(1, 10000)
		select new WorkItem{ Id = num};

	try
	{
		SplitWork(itemList);
	}
	catch {}
	
	Console.Read();
}

public void SplitWork(object items)
{
	var itemsEnum = items as IEnumerable<WorkItem>;
	
	int itemCount = itemsEnum.Count();
	if (itemCount > 1)
	{
	 	ThreadPool.QueueUserWorkItem(SplitWork, itemsEnum.Take(itemCount / 2));
		ThreadPool.QueueUserWorkItem(SplitWork, itemsEnum.Skip(itemCount / 2));
	}
	else
		itemsEnum.First().DoWork();
}

// Define other methods and classes here
public class WorkItem
{
	public int Id { get; set; }
	public void DoWork()
	{
		Console.WriteLine("Processing {0} on thread {1}", Id, System.Threading.Thread.CurrentThread.ManagedThreadId);
	}
}
