<Query Kind="Statements">
  <Namespace>System.Threading.Tasks</Namespace>
</Query>

var nums = Enumerable.Range(1,10000).ToArray();
var total = nums.Sum(num => num % 25 == 0 ? num : 0);
Console.WriteLine("Total Linq: {0}", total);

var totalParallel = nums.AsParallel().Sum(num => num % 25 == 0 ? num : 0);
Console.WriteLine("Total PLinq: {0}", total);


var totalFor = 0;
Parallel.ForEach(nums, num =>
{
	if (num % 25 == 0)
	 Interlocked.Add(ref totalFor, num);
		});
		
Console.WriteLine("Total For: {0}", totalFor);