<Query Kind="Program">
  <Reference>&lt;RuntimeDirectory&gt;\System.Net.dll</Reference>
  <Namespace>System.Threading.Tasks</Namespace>
  <Namespace>System.Net</Namespace>
</Query>

void Main()
{
	Task<string> page1 = DownloadStringAsTask(new Uri("http://www.ThinqLinq.com"));
	Task<string> page2 = DownloadStringAsTask(new Uri("http://www.CodeStock.org"));
	Task<string> page3 = DownloadStringAsTask(new Uri("http://www.AtlantaCodeCamp.org"));
	
	Task<int> Size1 = page1.ContinueWith(res => PageSize(res.Result));
	Task<int> Size2 = page2.ContinueWith(res => PageSize(res.Result));
	Task<int> Size3 = page3.ContinueWith(res => PageSize(res.Result));
	
	Task.Factory.ContinueWhenAll(new[] {Size1, Size2, Size3},
		tasks => Console.WriteLine("Total page size: " + Size1.Result + Size2.Result + Size3.Result));
		
	Console.WriteLine("Done");
	Console.Read();
}

// Define other methods and classes here
Task<string> DownloadStringAsTask(Uri address)
{
	TaskCompletionSource<string> taskSource = new TaskCompletionSource<string>();
	WebClient client = new WebClient();
	client.DownloadStringCompleted += (sender, e) =>
	{
		if (e.Error != null) taskSource.SetException(e.Error);
		else if (e.Cancelled) taskSource.TrySetCanceled();
		else taskSource.SetResult(e.Result);
	};
	client.DownloadStringAsync(address);
	return taskSource.Task;
}

int PageSize(string pageSource)
{
	return pageSource.Length;
}